LeeCode 1-?题[力扣系列]

文章目录


1.两数之和

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。

eg: 给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9 所以返回 [0, 1]

  • 思路1:暴力匹配
    时间复杂度:O(N^2)O(N)

  • 思路2:哈希表
    时间复杂度:O(N)O(N)

    下面演示哈希表解决方法

    public int[] twoSum(int[] nums, int target) {
    
    
  Map<Integer, Integer> map = new HashMap<>();

        for (int i = 0; i < nums.length; i++) {
    
    
        //把数组2,7,11,15放入map中,每个数字对应一个下标
        //2->1,7->2...
            map.put(nums[i], i);
        }
        for (int i = 0; i < nums.length; i++) {
    
    
        //遍历
        //1.将要匹配的数字 - 数组中遍历的每个数字 = TeFig
        //2.去map中查看TeFig是否存在,且不能本次i遍历
            int TeFig = target - nums[i];

		//如果找到返回i所在的位置,和map中另一个数组的位置
		//如果找不到返回null
            if (map.containsKey(TeFig) && map.get(TeFig) != i) {
    
    
               return new int[]{
    
    i, map.get(TeFig)};
            }
        }
        return null;
    }


转自:https://leetcode-cn.com/problems

猜你喜欢

转载自blog.csdn.net/SwaeLeeUknow/article/details/109151527